Subject: Re: [Qemu-devel] tap devices not receiving packets from a bridge

From: "Michael S. Tsirkin" <[email-masked]>
Date: Thu, 16 May 2013 09:27:43 +0300

On Thu, May 16, 2013 at 09:24:05AM +0300, Michael S. Tsirkin wrote:
> On Wed, May 15, 2013 at 12:00:03PM +0100, Nicholas Thomas wrote:
> > Hi again,
> > 
> > On Tue, 2013-05-14 at 15:49 +0100, Nicholas Thomas wrote:
> > > /sys/devices/virtual/net/t100/tun_flags is 0x5002 - so it looks like
> > > IFF_ONE_QUEUE was indeed unset by qemu (which is lacking the patch). It
> > > surprises me, but that's probably my fault, rather than qemu's.
> > 
> > 
> > I've rebuilt 1.4.1 with the IFF_ONE_QUEUE patch and tun_flags is now
> > 0x7002; unfortunately, I'm still seeing this bug, twice in five trials.
> > Symptoms in `ifconfig t100` now differ; overruns stays at 0, and
> > "dropped" increases monotonically as I send packets. Those packets do
> > appear if I tcpdump t100 on the host, but not if I tcpdump t100 on the
> > guest.
> > 
> > I've turned off gro in the guest, which makes no difference, and tried
> > changing the queue sizes (post-hoc) in both guest and host, in the hope
> > of causing them to be emptied out, clearing the condition; again to no
> > effect.
> > 
> > The VMs in question are bridged to a large (and busy) VLAN with no
> > ingress filtering to speak of; I guess what's happening is that the
> > transmit queue is filled up by that traffic while the guest is in ipxe,
> > and it never gets out of that state when it happens... so maybe there is
> > still an underlying problem?
> > 
> > /Nick
> 
> 
> Is this with or without vhost-net in host?

never mind, I see it's without.
Try to enable vhost-net (you'll have to switch to -netdev syntax
for that to work) and see if this help.
If it does it's likely a qemu bug if not probably a guest bug.

> -- 
> MST